#if defined _M_IX86
#pragma comment(linker,"/manifestdependency:\"type='win32' name='Microsoft.Windows.Common-Controls' version='6.0.0.0' processorArchitecture='x86' publicKeyToken='6595b64144ccf1df' language='*'\"")
#elif defined _M_IA64
#pragma comment(linker,"/manifestdependency:\"type='win32' name='Microsoft.Windows.Common-Controls' version='6.0.0.0' processorArchitecture='ia64' publicKeyToken='6595b64144ccf1df' language='*'\"")
#elif defined _M_X64
#pragma comment(linker,"/manifestdependency:\"type='win32' name='Microsoft.Windows.Common-Controls' version='6.0.0.0' processorArchitecture='amd64' publicKeyToken='6595b64144ccf1df' language='*'\"")
#else
#pragma comment(linker,"/manifestdependency:\"type='win32' name='Microsoft.Windows.Common-Controls' version='6.0.0.0' processorArchitecture='*' publicKeyToken='6595b64144ccf1df' language='*'\"")
#endif //CommonControls!

#pragma comment(lib, "gdiplus.lib")
#pragma comment(lib, "comctl32.lib")

#include <string>
#include <Windows.h>
#include <GdiPlus.h>
#include "Res.h"

using namespace Gdiplus;
using namespace std;


#define Version L"0.1"
#define sAbout L"About "##Version
#define sAtext L"Dieses Programm wurde von TheShadowAE aus der Autoit.de\nCommunity programmiert!\n\nDies ist Version "##Version
#define sHtext L"Bei Bugs, Vorschlgen oder Sonstigem bitte im Thread oder per PN melden, danke!\nAutoit.de - TheShadowAE\n\nWeitere ntzliche Informationen in den Dateien \\Filter.txt und \\Extensions\\HowTo.txt!"



class Bmp
{
public:
	Bitmap *bmp;
	BitmapData bmd;
	Bmp()
	{
		bmp=0;
	}
	Bmp(Bitmap *nb)
	{
		bmp=nb;
	}
	void Dispose()
	{
		if (bmp!=0) delete bmp;
		bmp=0;
	}
};


Graphics *gra;
HWND gui;
HWND Vorschau,OK,Inputs[10],Icon[2];
HMENU Datei, Hilfe, Mainm;
char classname[]="TheShadowAE's GUI";
Bmp img[3];
HDC dcGui;
int nowimg=0,oldnowimg=0;
char file[10001]="";
int gw,gh,iW,iH;
HANDLE thread=0;


void StartVorschau(int wtime=5000);
DWORD WINAPI VWait(LPVOID wait);
void EndVorschau();
bool AddMenu(HWND hwnd);
void Clean();
void RegisterClass();
void load();
void save();
int GetEncoderClsid(const WCHAR* format, CLSID* pClsid);
char* _FileDialog(bool save=false,char *title="",char *datei="",char *dir="",char *filter="Alle\0*.*\0\0",int flag=OFN_PATHMUSTEXIST|OFN_FILEMUSTEXIST,HWND parent=NULL);

extern void redraw();
extern void BFilter(Bmp bmp,int var[10],Bmp *neu);

LRESULT CALLBACK WndProc (HWND, UINT, WPARAM, LPARAM);






void load()
{
	WCHAR f[10001];
	MultiByteToWideChar(CP_ACP,MB_PRECOMPOSED,file,10001,f,10001);
	img[0].Dispose();
	img[1].Dispose();
	img[0].bmp=new Bitmap((WCHAR*)f);
	nowimg=0;
	iW=img[0].bmp->GetWidth();
	iH=img[0].bmp->GetHeight();
	gw=iW;
	gh=iH;
	if (gw>900)
	{
		gh=(int)(gh/(float)gw*900);
		gw=900;
	}
	if (gh>600)
	{
		gw=(int)(gw/(float)gh*600);
		gh=600;
	}
	redraw();
}

void save()
{
	if (img[nowimg].bmp==0) return;
	WCHAR form[10]=L"image/png";
	for (int i=0; i<4; i++)
	{
		form[i+6]=(WCHAR)*strlwr(&file[strlen(file)-3+i]); //must be lowercase
	}
	WCHAR nfile[10001];
	for (int i=0; i<10001; i++) nfile[i]=(WCHAR)file[i];
	CLSID clsid;
	if (GetEncoderClsid(form,&clsid)==-1) MessageBoxA(0,"","",0);
	img[nowimg].bmp->Save(nfile,&clsid,NULL);
}

int GetEncoderClsid(const WCHAR* format, CLSID* pClsid)
{
        UINT  num = 0;          // number of image encoders
        UINT  size = 0;         // size of the image encoder array in bytes

        ImageCodecInfo* pImageCodecInfo = NULL;

        GetImageEncodersSize(&num, &size);
        if(size == 0)
        return -1;  // Failure

        pImageCodecInfo = (ImageCodecInfo*)(malloc(size));
        if(pImageCodecInfo == NULL)
        return -1;  // Failure

        GetImageEncoders(num, size, pImageCodecInfo);

        for(UINT j = 0; j < num; ++j)
        {
                if( wcscmp(pImageCodecInfo[j].MimeType, format) == 0 )
                {
                        *pClsid = pImageCodecInfo[j].Clsid;
                        free(pImageCodecInfo);
                        return j;  // Success
                }
        }

        free(pImageCodecInfo);
        return -1;  // Failure
}

char* _FileDialog(bool save,char *title,char *datei,char *dir,char *filter,int flag,HWND parent)
{
	OPENFILENAMEA	ofn={0};
	ofn.lStructSize		= sizeof(OPENFILENAME);
	ofn.hwndOwner		= parent;
	ofn.lpstrFilter		= filter;
	ofn.lpstrTitle		= title;
	ofn.nMaxFile		= 10000;
	ofn.lpstrFile		= datei;
	ofn.lpstrInitialDir = dir;

	if(!save)
	{
		if(GetOpenFileNameA(&ofn))
		{
			return (char*)ofn.lpstrFile;
		}
	}
	else
	{
		if(GetSaveFileNameA(&ofn))
			return (char*)ofn.lpstrFile;
	}

	return "";
}



ULONG_PTR gdiplusToken;
void _GDIPlusStartup()
{
    GdiplusStartupInput gdiplusStartupInput;
    GdiplusStartup(&gdiplusToken, &gdiplusStartupInput, NULL);
}

void _GDIPlusShutdown()
{
    GdiplusShutdown(gdiplusToken);
}



void CreateGui()
{
	int w=1010,h=640;
	long screenx = (long)GetSystemMetrics( SM_CXFULLSCREEN );
    long screeny = (long)GetSystemMetrics( SM_CYFULLSCREEN );
    int mx=screenx/2-w/2;
    int my=screeny/2-h/2;

	RegisterClass();

	HMODULE hMod=GetModuleHandle(NULL);

	RECT r={0,0,w,h};
	AdjustWindowRect(&r,WS_OVERLAPPEDWINDOW,TRUE);

	gui = CreateWindowEx(0,(LPCWSTR)classname,L"Filter und Effekte fr Bilder",WS_OVERLAPPEDWINDOW,
		mx,my,r.right-r.left,r.bottom-r.top,
		NULL,(HMENU)NULL,hMod,NULL);
	SendMessage(gui,(UINT)WM_SETFONT,(WPARAM)GetStockObject(DEFAULT_GUI_FONT),
		(LPARAM)MAKELPARAM(FALSE,0));

	gra=Graphics::FromHWND(gui);

	//Controls
	HWND temp=CreateWindow(L"Static",L"Divisor:",WS_VISIBLE|WS_CHILD,8,123,39,17,gui,0,hMod,0);
	Icon[0]=CreateWindow(L"Static",L"#108"/*undo icon*/,WS_VISIBLE|WS_CHILD|SS_NOTIFY|SS_ICON|SS_REALSIZEIMAGE,192,11,16,16,gui,0,hMod,0);
	Icon[1]=CreateWindow(L"Static",L"#109"/*redo icon*/,WS_VISIBLE|WS_CHILD|SS_NOTIFY|SS_ICON|SS_REALSIZEIMAGE,216,11,16,16,gui,0,hMod,0);
	Vorschau=CreateWindow(L"Button",L"Vorschau",WS_VISIBLE|WS_CHILD,8,152,89,25,gui,0,hMod,0);
	OK=CreateWindow(L"Button",L"OK",WS_VISIBLE|WS_CHILD,8,184,89,25,gui,0,hMod,0);
	Inputs[0]=CreateWindow(L"Edit",L"0",WS_VISIBLE|WS_CHILD|WS_BORDER,8,40,25,21,gui,0,hMod,0);
	Inputs[1]=CreateWindow(L"Edit",L"0",WS_VISIBLE|WS_CHILD|WS_BORDER,40,40,25,21,gui,0,hMod,0);
	Inputs[2]=CreateWindow(L"Edit",L"0",WS_VISIBLE|WS_CHILD|WS_BORDER,72,40,25,21,gui,0,hMod,0);
	Inputs[3]=CreateWindow(L"Edit",L"0",WS_VISIBLE|WS_CHILD|WS_BORDER,8,64,25,21,gui,0,hMod,0);
	Inputs[4]=CreateWindow(L"Edit",L"1",WS_VISIBLE|WS_CHILD|WS_BORDER,40,64,25,21,gui,0,hMod,0);
	Inputs[5]=CreateWindow(L"Edit",L"0",WS_VISIBLE|WS_CHILD|WS_BORDER,72,64,25,21,gui,0,hMod,0);
	Inputs[6]=CreateWindow(L"Edit",L"0",WS_VISIBLE|WS_CHILD|WS_BORDER,8,88,25,21,gui,0,hMod,0);
	Inputs[7]=CreateWindow(L"Edit",L"0",WS_VISIBLE|WS_CHILD|WS_BORDER,40,88,25,21,gui,0,hMod,0);
	Inputs[8]=CreateWindow(L"Edit",L"0",WS_VISIBLE|WS_CHILD|WS_BORDER,72,88,25,21,gui,0,hMod,0);
	Inputs[9]=CreateWindow(L"Edit",L"1",WS_VISIBLE|WS_CHILD|WS_BORDER,72,120,25,21,gui,0,hMod,0);

	SendMessage(temp,(UINT)WM_SETFONT,(WPARAM)GetStockObject(DEFAULT_GUI_FONT),(LPARAM)MAKELPARAM(FALSE,0));
	SendMessage(Vorschau,(UINT)WM_SETFONT,(WPARAM)GetStockObject(DEFAULT_GUI_FONT),(LPARAM)MAKELPARAM(FALSE,0));
	SendMessage(OK,(UINT)WM_SETFONT,(WPARAM)GetStockObject(DEFAULT_GUI_FONT),(LPARAM)MAKELPARAM(FALSE,0));
	SendMessage(Icon[0],(UINT)WM_SETFONT,(WPARAM)GetStockObject(DEFAULT_GUI_FONT),(LPARAM)MAKELPARAM(FALSE,0));
	SendMessage(Icon[1],(UINT)WM_SETFONT,(WPARAM)GetStockObject(DEFAULT_GUI_FONT),(LPARAM)MAKELPARAM(FALSE,0));
	for (int x=0; x<10; x++) SendMessage(Inputs[x],(UINT)WM_SETFONT,(WPARAM)GetStockObject(DEFAULT_GUI_FONT),(LPARAM)MAKELPARAM(FALSE,0));
}


void StartVorschau(int wtime)
{
	if (thread!=0)
	{
		SuspendThread(thread);
		TerminateThread(thread,0);
	}
	thread=CreateThread(NULL,0,VWait,(LPVOID)wtime,0,0);
}

DWORD WINAPI VWait(LPVOID wait)
{
	Sleep((int)wait);
	EndVorschau();
	ExitThread(0);
	return 0;
}

void EndVorschau()
{
	if (nowimg!=2) return;
	nowimg=oldnowimg;
	img[2].Dispose();
	redraw();
	CloseHandle(thread);
	thread=0;
}


LRESULT CALLBACK WndProc (HWND hwnd, UINT Msg, WPARAM wParam, LPARAM lParam)
{
	char png[5]=".png";
	switch(Msg)
	{
	case WM_COMMAND:
		if ((HWND)lParam==Vorschau)
		{
			EndVorschau();
			oldnowimg=nowimg;
			nowimg=2;
			int var[10];
			for (int i=0; i<10; i++)
			{
				char b[5]="";
				GetWindowTextA(Inputs[i],b,4);
				var[i]=atoi(b);
			}
			BFilter(img[oldnowimg],var,&img[2]);
			redraw();
			StartVorschau();
		}
		else if ((HWND)lParam==OK)
		{
			EndVorschau();
			if (nowimg==0) img[1].Dispose();
			else
			{
				img[0].Dispose();
				img[0]=img[1];
			}
			nowimg=1;
			int var[10];
			for (int i=0; i<10; i++)
			{
				char b[5]="";
				GetWindowTextA(Inputs[i],b,4);
				var[i]=atoi(b);
			}
			BFilter(img[0],var,&img[1]);
			redraw();
		}
		else if ((HWND)lParam==Icon[0])
		{
			if (nowimg==2) EndVorschau();
			if (nowimg==1) nowimg=0;
			redraw();
		}
		else if ((HWND)lParam==Icon[1])
		{
			if (nowimg==2) EndVorschau();
			if (nowimg==0 && img[1].bmp!=0) nowimg=1;
			redraw();
		}
		switch(LOWORD(wParam))
		{
		case ID_close:
			DestroyWindow(hwnd);
			break;
		case ID_open:
			_FileDialog(false,"Bild ffnen",file,"","Bilder\0*.bmp;*.jpg;*.png\0\0",OFN_PATHMUSTEXIST|OFN_FILEMUSTEXIST,gui);
			load();
			break;
		case ID_saveas:
			_FileDialog(true,"Bild speichern",file,"","Bilder\0*.bmp;*.jpg;*.png\0\0",0,gui);
			if (file[strlen(file)-4]!='.') for (int i=strlen(file)-1; i<strlen(file)+4; i++) file[i]=png[i-strlen(file)+1];
		case ID_save:
			save();
			break;
		case ID_help:
			MessageBox(gui,sHtext,L"Hilfe",0);
			break;
		case ID_about:
			MessageBox(gui,(LPCWSTR)sAtext,(LPCWSTR)sAbout,0);
			break;
		}
		break;
	case WM_CLOSE:
		DestroyWindow(hwnd);
		break;
	case WM_DESTROY:
		Clean();
		PostQuitMessage(0);
		break;
	case WM_ACTIVATE:
		if (wParam!=0) redraw();
		break;
	default:
		return DefWindowProc(hwnd,Msg,wParam,lParam);
	}
	return 0;
}


void RegisterClass()
{
	WNDCLASS Wc;
	Wc.style = CS_HREDRAW | CS_VREDRAW | CS_OWNDC;
	Wc.lpfnWndProc = WndProc;
	Wc.cbClsExtra = 0;
	Wc.cbWndExtra = 0;
	Wc.hInstance = GetModuleHandle(NULL);
	Wc.hIcon = LoadIcon(Wc.hInstance,MAKEINTRESOURCE(hIicon));
	Wc.hCursor = LoadCursor(NULL,IDC_ARROW);
	Wc.hbrBackground = (HBRUSH)GetSysColorBrush(COLOR_BTNFACE);
	Wc.lpszMenuName = NULL;
	Wc.lpszClassName = (LPCWSTR)classname;
	RegisterClass(&Wc);
}


bool AddMenu(HWND hwnd)
{
	Mainm=CreateMenu();
	Datei=CreateMenu();
	Hilfe=CreateMenu();
	InsertMenu(Mainm,0,MF_POPUP,(UINT)Datei,L"Datei");
	InsertMenu(Mainm,0,MF_POPUP,(UINT)Hilfe,L"Hilfe");
	AppendMenu(Datei,MF_STRING,ID_open,L"ffnen");
	AppendMenu(Datei,MF_STRING,ID_save,L"Speichern");
	AppendMenu(Datei,MF_STRING,ID_saveas,L"Speichern unter");
	AppendMenu(Datei,MF_SEPARATOR,0,L"");
	AppendMenu(Datei,MF_STRING,ID_close,L"Schlieen");
	AppendMenu(Hilfe,MF_STRING,ID_help,L"Hilfe");
	AppendMenu(Hilfe,MF_STRING,ID_about,L"About");
	if (!SetMenu(hwnd,Mainm)) {
		return false;
	}
	return true;
}

void Clean()
{
	DestroyMenu(Hilfe);
	DestroyMenu(Datei);
	DestroyMenu(Mainm);
	img[0].Dispose();
	img[1].Dispose();
	img[2].Dispose();
	gra->~Graphics();
	UnregisterClass((LPCWSTR)classname,NULL);
}


