#include "main.h"
#include <commctrl.h>


void _tproc(HWND,UINT,UINT_PTR,DWORD);
void redraw();
void BFilter(Bmp bmp,int var[10],Bmp *neu);




int WINAPI WinMain(HINSTANCE hInst,HINSTANCE hPrev,LPSTR CmdLine,int CmdShow)
{
	InitCommonControls();
	_GDIPlusStartup();
	CreateGui();
	AddMenu(gui);
	ShowWindow(gui,SW_SHOW);

	dcGui=GetDC(gui);
	UINT_PTR timer= SetTimer(0,0,1000,(TIMERPROC)_tproc);


	MSG Msg;
	while(GetMessage(&Msg,NULL,0,0))
	{
		TranslateMessage(&Msg);
		DispatchMessage(&Msg);
		Sleep(0);
	}
	KillTimer(0,timer);
	ReleaseDC(gui,dcGui);
	void _GDIPlusShutdown();
	return Msg.wParam;
}








void _ASMF(Bmp bmp,Bmp *neu,int varx[10])
{
	DWORD var[10]; //fr den Zugriff
	for (int i=0; i<10; i++) var[i]=varx[i];
	DWORD stride=bmp.bmd.Stride;
	DWORD sc1=(DWORD)bmp.bmd.Scan0+4+stride,sc2=(DWORD)neu->bmd.Scan0+4+stride;
	DWORD c[4]={0};
	int w=bmp.bmd.Width-1,h=bmp.bmd.Height-1;
	__asm
	{
		finit
		movd xmm1,dword ptr[var+36] // xmm1=Divisor
		pshufd xmm1,xmm1,0
		cvtdq2ps xmm1,xmm1
		mov eax,0
		movd xmm2,eax
		pshufd xmm2,xmm2,0 // xmm2=0
		mov eax,255
		movd xmm3,eax
		pshufd xmm3,xmm3,0 // xmm3 je=255
		mov eax,0xFFFFFFFF
		movd xmm5,eax
		pshufd xmm5,xmm5,0 // xmm5=0xFF...

		mov eax,w //berechnen, wie viel bytes pro zeile zurck mssen
		dec eax
		imul eax,4
		push eax

		mov esi,sc1
		mov edi,sc2

		mov edx,h
		dec edx
for_y:
			mov ecx,w
			dec ecx
for_x:

				push edx
				push ecx
				mov edx,0
				sub esi,stride
				sub esi,4
				mov ecx,3
ffy:
					push ecx
					mov ecx,3
ffx:
						mov ebx,[esi]
						movzx eax,bl //abgr
						imul eax,dword ptr[var+edx]
						add dword ptr[c+4],eax
						movzx eax,bh
						imul eax,dword ptr[var+edx]
						add dword ptr[c+8],eax
						shr ebx,16
						movzx eax,bl
						imul eax,dword ptr[var+edx]
						add dword ptr[c+12],eax

						add edx,4
						add esi,4
						dec ecx
						jnz ffx
					sub esi,12
					add esi,stride
					pop ecx
					dec ecx
					jnz ffy
				add esi,4
				sub esi,stride
				sub esi,stride

				pop ecx
				pop edx

				movdqu xmm0,xmmword ptr[c]
				cvtdq2ps xmm0,xmm0
				divps xmm0,xmm1
				cvtps2dq xmm0,xmm0
				movdqu xmm4,xmm0 // kopieren zum vergleichen
				pcmpgtd xmm4,xmm3 // jeweils >255, vorheriges ergebnis wird berschrieben
				movdqu xmm7,xmm4 // sichern zum zusammenfgen
				pxor xmm7,xmm5 // sicherung zum zusammenfgen frs zusammenfgen ivnertieren
				pand xmm4,xmm3 // was >255 ist, wird zu 111.., dann and mit 255, alles was >255 ist, wird 255
				movdqu xmm6,xmm0 // nochmal getrennt kopiert
				pcmpgtd xmm6,xmm2 // alles was <=0 ist wird 000..
				pand xmm7,xmm0 // ergebnisse zusammenfgen
				por xmm7,xmm4
				pand xmm7,xmm6
				movdqu xmmword ptr[c],xmm7 // die richtigen daten stehen jetzt in xmm7

				mov eax,dword ptr[c+4]
				mov byte ptr[edi],al
				mov eax,dword ptr[c+8]
				mov byte ptr[edi+1],al
				mov eax,dword ptr[c+12]
				mov byte ptr[edi+2],al

				movdqu xmmword ptr[c],xmm2 //a=r=g=b=0

				add esi,4
				add edi,4
				dec ecx
				jnz for_x
			add esi,stride //nchste Zeile
			add edi,stride
			sub esi,[esp]
			sub edi,[esp]
			dec edx
			jnz for_y
		pop eax
	}
}

void BFilter(Bmp bmp,int var[10],Bmp *neu)
{
	if (bmp.bmp==0) return;
	if (var[9]<1) var[9]=1;
	Bitmap *b=new Bitmap(iW,iH,PixelFormat32bppARGB);
	Graphics g(b);
	g.DrawImage(bmp.bmp,0,0,iW,iH);
	g.~Graphics();
	neu->bmp=b;

	for (int x=1; x+500<iW; x+=500)
		for (int y=1; y+400<iH; y+=400)
		{
			Rect rect(x-1,y-1,502,402);
			bmp.bmp->LockBits(&rect,3/*readwrite*/,PixelFormat32bppARGB,&bmp.bmd);
			neu->bmp->LockBits(&rect,3			  ,PixelFormat32bppARGB,&neu->bmd);
			_ASMF(bmp,neu,var);
			bmp.bmp->UnlockBits(&bmp.bmd);
			neu->bmp->UnlockBits(&neu->bmd);
		};
	int wue=(iW-1)%500+1,hue=(iH-1)%400+1;
	int x=(int)((iW-1)/500)*500,y=(int)((iH-1)/400)*400;
	for (int iy=1; iy+400<iH; iy+=400)
	{
		Rect rect(x,iy-1,iW-x,402);
		bmp.bmp->LockBits(&rect,3/*readwrite*/,PixelFormat32bppARGB,&bmp.bmd);
		neu->bmp->LockBits(&rect,3			  ,PixelFormat32bppARGB,&neu->bmd);
		_ASMF(bmp,neu,var);
		bmp.bmp->UnlockBits(&bmp.bmd);
		neu->bmp->UnlockBits(&neu->bmd);
	}
	for (int ix=1; ix+500<iW; ix+=500)
	{
		Rect rect(ix-1,y,502,iH-y);
		bmp.bmp->LockBits(&rect,3/*readwrite*/,PixelFormat32bppARGB,&bmp.bmd);
		neu->bmp->LockBits(&rect,3			  ,PixelFormat32bppARGB,&neu->bmd);
		_ASMF(bmp,neu,var);
		bmp.bmp->UnlockBits(&bmp.bmd);
		neu->bmp->UnlockBits(&neu->bmd);
	}
	Rect rect(x,y,iW-x,iH-y);
	bmp.bmp->LockBits(&rect,3/*readwrite*/,PixelFormat32bppARGB,&bmp.bmd);
	neu->bmp->LockBits(&rect,3			  ,PixelFormat32bppARGB,&neu->bmd);
	_ASMF(bmp,neu,var);
	bmp.bmp->UnlockBits(&bmp.bmd);
	neu->bmp->UnlockBits(&neu->bmd);
}


void redraw()
{
	if (img[nowimg].bmp!=0)
	{
		gra->DrawImage(img[nowimg].bmp,110,40,gw,gh);
	}
}


void _tproc(HWND,UINT,UINT_PTR,DWORD)
{
	redraw();
}
